#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_un_lock_battle.h"
#include "FileEncrypt.h"
std::auto_ptr<M_un_lock_battle> M_un_lock_battle::msSingleton(nullptr);

int M_un_lock_battle::GetCount()
{
	return (int)mMapData.size();
}

const M_un_lock_battleData* M_un_lock_battle::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int64_t, M_un_lock_battleData>& M_un_lock_battle::GetMapData()
{
	return mMapData;
}

void M_un_lock_battle::Reload()
{
	mMapData.clear();
	Load();
}

void M_un_lock_battle::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_un_lock_battleData data;
		{
			int64_t temp = 0;
			const char* str = element->Attribute("ID");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mID = temp;
		}
		data.mbattle_type = element->IntAttribute("battle_type");
		data.mun_lock_magic = element->IntAttribute("un_lock_magic");
		data.mdemand = element->IntAttribute("demand");
		data.mprohibit = element->IntAttribute("prohibit");
		{
			const char* use_magic = element->Attribute("use_magic");
			std::vector<std::string> vecuse_magic;
			boost::split(vecuse_magic, use_magic, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecuse_magic.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecuse_magic[i].c_str(), &temp))
				{
					data.muse_magic.push_back(temp);
				}
			}
		}
		{
			const char* fish_wave = element->Attribute("fish_wave");
			std::vector<std::string> vecfish_wave;
			boost::split(vecfish_wave, fish_wave, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecfish_wave.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecfish_wave[i].c_str(), &temp))
				{
					data.mfish_wave.push_back(temp);
				}
			}
		}
		data.mfish_scheme = element->Attribute("fish_scheme");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_un_lock_battle::Load()
{
	Load("../Config/M_un_lock_battle.xml");
}

M_un_lock_battle* M_un_lock_battle::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_un_lock_battle());
	}
	return msSingleton.get();
}
